Index: tests/src/io/test-source.c
===================================================================
--- tests/src/io/test-source.c	(revision 919139be3e6fd5c9d515348e02966664e385b561)
+++ tests/src/io/test-source.c	(revision 447c673fd7b5a2836cfb1d6441b7b36a4bf66a56)
@@ -28,8 +28,9 @@
   char_t *source_path = argv[1];
 
+
+  aubio_source_t* s =
+    new_aubio_source(source_path, samplerate, hop_size);
+  if (!s) { err = 1; goto beach; }
   fvec_t *vec = new_fvec(hop_size);
-
-  aubio_source_t* s = new_aubio_source(source_path, samplerate, hop_size);
-  if (!s) { err = 1; goto beach; }
 
   if (samplerate == 0 ) samplerate = aubio_source_get_samplerate(s);
@@ -44,8 +45,7 @@
     n_frames / hop_size, source_path);
 
+  del_fvec (vec);
   del_aubio_source (s);
 beach:
-  del_fvec (vec);
-
   return err;
 }
Index: tests/src/io/test-source_apple_audio.c
===================================================================
--- tests/src/io/test-source_apple_audio.c	(revision 919139be3e6fd5c9d515348e02966664e385b561)
+++ tests/src/io/test-source_apple_audio.c	(revision 447c673fd7b5a2836cfb1d6441b7b36a4bf66a56)
@@ -12,31 +12,45 @@
     err = 2;
     PRINT_ERR("not enough arguments\n");
-    PRINT_MSG("usage: %s <source_path> [samplerate]\n", argv[0]);
+    PRINT_MSG("read a wave file as a mono vector\n");
+    PRINT_MSG("usage: %s <source_path> [samplerate] [hop_size]\n", argv[0]);
+    PRINT_MSG("examples:\n");
+    PRINT_MSG(" - read file.wav at original samplerate\n");
+    PRINT_MSG("       %s file.wav\n", argv[0]);
+    PRINT_MSG(" - read file.wav at 32000Hz\n");
+    PRINT_MSG("       %s file.aif 32000\n", argv[0]);
+    PRINT_MSG(" - read file.wav at original samplerate with 4096 blocks\n");
+    PRINT_MSG("       %s file.wav 0 4096 \n", argv[0]);
     return err;
   }
 
 #if __APPLE__
-  uint_t samplerate = 32000;
+  uint_t samplerate = 0;
   uint_t hop_size = 256;
   uint_t n_frames = 0, read = 0;
   if ( argc == 3 ) samplerate = atoi(argv[2]);
+  if ( argc == 4 ) hop_size = atoi(argv[3]);
 
   char_t *source_path = argv[1];
 
+
+  aubio_source_apple_audio_t * s =
+    new_aubio_source_apple_audio(source_path, samplerate, hop_size);
+  if (!s) { err = 1; goto beach; }
   fvec_t *vec = new_fvec(hop_size);
-  aubio_source_apple_audio_t * s = new_aubio_source_apple_audio(source_path, samplerate, hop_size);
+
   if (samplerate == 0 ) samplerate = aubio_source_apple_audio_get_samplerate(s);
-
-  if (!s) { err = 1; goto beach; }
 
   do {
     aubio_source_apple_audio_do(s, vec, &read);
-    // fvec_print (vec);
+    fvec_print (vec);
     n_frames += read;
   } while ( read == hop_size );
 
+  PRINT_MSG("read %d frames at %dHz (%d blocks) from %s\n", n_frames, samplerate,
+    n_frames / hop_size, source_path);
+
+  del_fvec (vec);
+  del_aubio_source_apple_audio (s);
 beach:
-  del_aubio_source_apple_audio (s);
-  del_fvec (vec);
 #else
   err = 3;
Index: tests/src/io/test-source_sndfile.c
===================================================================
--- tests/src/io/test-source_sndfile.c	(revision 919139be3e6fd5c9d515348e02966664e385b561)
+++ tests/src/io/test-source_sndfile.c	(revision 447c673fd7b5a2836cfb1d6441b7b36a4bf66a56)
@@ -13,5 +13,13 @@
     err = 2;
     PRINT_ERR("not enough arguments\n");
-    PRINT_MSG("usage: %s <source_path> [samplerate]\n", argv[0]);
+    PRINT_MSG("read a wave file as a mono vector\n");
+    PRINT_MSG("usage: %s <source_path> [samplerate] [hop_size]\n", argv[0]);
+    PRINT_MSG("examples:\n");
+    PRINT_MSG(" - read file.wav at original samplerate\n");
+    PRINT_MSG("       %s file.wav\n", argv[0]);
+    PRINT_MSG(" - read file.wav at 32000Hz\n");
+    PRINT_MSG("       %s file.aif 32000\n", argv[0]);
+    PRINT_MSG(" - read file.wav at original samplerate with 4096 blocks\n");
+    PRINT_MSG("       %s file.wav 0 4096 \n", argv[0]);
     return err;
   }
@@ -22,10 +30,14 @@
   uint_t n_frames = 0, read = 0;
   if ( argc == 3 ) samplerate = atoi(argv[2]);
+  if ( argc == 4 ) hop_size = atoi(argv[3]);
 
   char_t *source_path = argv[1];
 
+
+  aubio_source_sndfile_t * s =
+    new_aubio_source_sndfile(source_path, samplerate, hop_size);
+  if (!s) { err = 1; goto beach; }
   fvec_t *vec = new_fvec(hop_size);
-  aubio_source_sndfile_t * s = new_aubio_source_sndfile(source_path, samplerate, hop_size);
-  if (!s) { err = 1; goto beach; }
+
   if (samplerate == 0 ) samplerate = aubio_source_sndfile_get_samplerate(s);
 
@@ -36,7 +48,10 @@
   } while ( read == hop_size );
 
+  PRINT_MSG("read %d frames at %dHz (%d blocks) from %s\n", n_frames, samplerate,
+    n_frames / hop_size, source_path);
+
+  del_fvec (vec);
   del_aubio_source_sndfile (s);
 beach:
-  del_fvec (vec);
 #else
   err = 3;