Index: src/onset/onset.h
===================================================================
--- src/onset/onset.h	(revision acd97d1038823180179882ebb3d3dc72da0fd3e3)
+++ src/onset/onset.h	(revision 479adba0d446f264f01ad247fe9bf52f46fcadd4)
@@ -26,5 +26,5 @@
   in these functions. When onsets are found above a given silence threshold,
   and after a minimum inter-onset interval, the output vector returned by
-  ::aubio_onset_do is filled with `1`. Otherwise, the output vector remains
+  aubio_onset_do() is filled with `1`. Otherwise, the output vector remains
   `0`.
 
@@ -55,4 +55,6 @@
   \param samplerate sampling rate of the input signal
 
+  \return newly created ::aubio_onset_t
+
 */
 aubio_onset_t * new_aubio_onset (char_t * method,
@@ -61,5 +63,5 @@
 /** execute onset detection
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param input new audio vector of length hop_size
   \param onset output vector of length 1, containing 0 if no onset was found,
@@ -73,5 +75,5 @@
 
   The final onset detection time, in samples, can be obtained with
-  ::aubio_onset_get_last_onset. It can also be derived from `offset` as
+  aubio_onset_get_last(). It can also be derived from `offset` as
   follows:
 
@@ -82,5 +84,5 @@
   where `total_frames` is the total number of frames processed so far, and
   `delay` is the current delay of the onset object, as returned by
-  ::aubio_onset_get_delay.
+  aubio_onset_get_delay().
 
 */
@@ -89,5 +91,7 @@
 /** get the time of the latest onset detected, in samples
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
+
+  \return onset detection timestamps (in samples)
 
 */
@@ -96,5 +100,7 @@
 /** get the time of the latest onset detected, in seconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
+
+  \return onset detection timestamps (in seconds)
 
 */
@@ -103,5 +109,7 @@
 /** get the time of the latest onset detected, in milliseconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
+
+  \return onset detection timestamps (in milliseconds)
 
 */
@@ -110,5 +118,5 @@
 /** set onset detection silence threshold
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param silence new silence detection threshold
 
@@ -118,5 +126,5 @@
 /** get onset detection function
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return the current value of the descriptor
 
@@ -126,5 +134,5 @@
 /** get thresholded onset detection function
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return the value of the thresholded descriptor
 
@@ -134,5 +142,5 @@
 /** set onset detection peak picking threshold
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param threshold new peak-picking threshold
 
@@ -142,5 +150,5 @@
 /** set minimum inter onset interval in samples
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param minioi minimum interval between two consecutive onsets (in
   samples)
@@ -151,5 +159,5 @@
 /** set minimum inter onset interval in seconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param minioi minimum interval between two consecutive onsets (in
   seconds)
@@ -160,5 +168,5 @@
 /** set minimum inter onset interval in milliseconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param minioi minimum interval between two consecutive onsets (in
   milliseconds)
@@ -169,5 +177,5 @@
 /** set minimum inter onset interval in samples
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param delay constant system delay to take back from detection time
   (in samples)
@@ -178,5 +186,5 @@
 /** set minimum inter onset interval in seconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param delay constant system delay to take back from detection time
   (in seconds)
@@ -187,5 +195,5 @@
 /** set minimum inter onset interval in milliseconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \param delay constant system delay to take back from detection time
   (in milliseconds)
@@ -196,5 +204,5 @@
 /** get minimum inter onset interval in samples
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return minimum interval between two consecutive onsets (in
   samples)
@@ -205,5 +213,5 @@
 /** get minimum inter onset interval in seconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return minimum interval between two consecutive onsets (in
   seconds)
@@ -214,5 +222,5 @@
 /** get minimum inter onset interval in milliseconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return minimum interval between two consecutive onsets (in
   milliseconds)
@@ -223,5 +231,5 @@
 /** get minimum inter onset interval in samples
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return constant system delay to take back from detection time
   (in samples)
@@ -232,5 +240,5 @@
 /** get minimum inter onset interval in seconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return constant system delay to take back from detection time
   (in seconds)
@@ -241,5 +249,5 @@
 /** get minimum inter onset interval in milliseconds
 
-  \param o onset detection object as returned by ::new_aubio_onset
+  \param o onset detection object as returned by new_aubio_onset()
   \return constant system delay to take back from detection time
   (in milliseconds)