Index: src/aubio_priv.h
===================================================================
--- src/aubio_priv.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/aubio_priv.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2003-2009 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
@@ -21,5 +21,5 @@
 /** @file
  * Private include file
- * 
+ *
  * This file is for inclusion from _within_ the library only.
  */
@@ -30,5 +30,5 @@
 /*********************
  *
- * External includes 
+ * External includes
  *
  */
@@ -72,5 +72,5 @@
 
 /****
- * 
+ *
  * SYSTEM INTERFACE
  *
Index: src/cvec.h
===================================================================
--- src/cvec.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/cvec.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2003-2013 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
Index: src/fmat.h
===================================================================
--- src/fmat.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/fmat.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2009-2013 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2009-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
@@ -63,5 +63,5 @@
   \param s vector to read from
   \param channel channel to read from
-  \param position sample position to read from 
+  \param position sample position to read from
 
 */
@@ -70,8 +70,8 @@
 /** write sample value in a buffer
 
-  \param s vector to write to 
+  \param s vector to write to
   \param data value to write in s->data[channel][position]
-  \param channel channel to write to 
-  \param position sample position to write to 
+  \param channel channel to write to
+  \param position sample position to write to
 
 */
@@ -102,7 +102,7 @@
 smpl_t ** fmat_get_data(fmat_t *s);
 
-/** print out fmat data 
+/** print out fmat data
 
-  \param s vector to print out 
+  \param s vector to print out
 
 */
@@ -117,5 +117,5 @@
 void fmat_set(fmat_t *s, smpl_t val);
 
-/** set all elements to zero 
+/** set all elements to zero
 
   \param s vector to modify
@@ -124,5 +124,5 @@
 void fmat_zeros(fmat_t *s);
 
-/** set all elements to ones 
+/** set all elements to ones
 
   \param s vector to modify
@@ -149,5 +149,5 @@
 void fmat_weight(fmat_t *s, fmat_t *weight);
 
-/** make a copy of a matrix 
+/** make a copy of a matrix
 
   \param s source vector
Index: src/fvec.h
===================================================================
--- src/fvec.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/fvec.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2003-2013 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
@@ -87,5 +87,5 @@
 
   \param s vector to read from
-  \param position sample position to read from 
+  \param position sample position to read from
 
 */
@@ -94,7 +94,7 @@
 /** write sample value in a buffer
 
-  \param s vector to write to 
+  \param s vector to write to
   \param data value to write in s->data[position]
-  \param position sample position to write to 
+  \param position sample position to write to
 
 */
@@ -108,7 +108,7 @@
 smpl_t * fvec_get_data(fvec_t *s);
 
-/** print out fvec data 
+/** print out fvec data
 
-  \param s vector to print out 
+  \param s vector to print out
 
 */
@@ -123,5 +123,5 @@
 void fvec_set_all (fvec_t *s, smpl_t val);
 
-/** set all elements to zero 
+/** set all elements to zero
 
   \param s vector to modify
@@ -130,5 +130,5 @@
 void fvec_zeros(fvec_t *s);
 
-/** set all elements to ones 
+/** set all elements to ones
 
   \param s vector to modify
Index: src/lvec.h
===================================================================
--- src/lvec.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/lvec.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2003-2013 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
@@ -62,5 +62,5 @@
 
   \param s vector to read from
-  \param position sample position to read from 
+  \param position sample position to read from
 
 */
@@ -69,7 +69,7 @@
 /** write sample value in a buffer
 
-  \param s vector to write to 
+  \param s vector to write to
   \param data value to write in s->data[position]
-  \param position sample position to write to 
+  \param position sample position to write to
 
 */
@@ -83,7 +83,7 @@
 lsmp_t * lvec_get_data(lvec_t *s);
 
-/** print out lvec data 
+/** print out lvec data
 
-  \param s vector to print out 
+  \param s vector to print out
 
 */
@@ -98,5 +98,5 @@
 void lvec_set_all(lvec_t *s, smpl_t val);
 
-/** set all elements to zero 
+/** set all elements to zero
 
   \param s vector to modify
@@ -105,5 +105,5 @@
 void lvec_zeros(lvec_t *s);
 
-/** set all elements to ones 
+/** set all elements to ones
 
   \param s vector to modify
Index: src/mathutils.h
===================================================================
--- src/mathutils.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/mathutils.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2003-2014 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
@@ -83,12 +83,12 @@
 
 /** swap the left and right halves of a vector
-  
+
   This function swaps the left part of the signal with the right part of the
 signal. Therefore
 
   \f$ a[0], a[1], ..., a[\frac{N}{2}], a[\frac{N}{2}+1], ..., a[N-1], a[N] \f$
-  
+
   becomes
-  
+
   \f$ a[\frac{N}{2}+1], ..., a[N-1], a[N], a[0], a[1], ..., a[\frac{N}{2}] \f$
 
@@ -96,5 +96,5 @@
 can be used before computing the FFT to simplify the phase relationship of the
 resulting spectrum. See Amalia de Götzen's paper referred to above.
-  
+
 */
 void fvec_shift (fvec_t * v);
@@ -112,18 +112,18 @@
 
   The High Frequency Content is defined as \f$ \sum_0^{N-1} (k+1) v[k] \f$.
- 
-  \param v vector to get the energy from 
+
+  \param v vector to get the energy from
 
   \return the HFC of v
- 
+
 */
 smpl_t fvec_local_hfc (fvec_t * v);
 
-/** computes the p-norm of a vector 
- 
+/** computes the p-norm of a vector
+
   Computes the p-norm of a vector for \f$ p = \alpha \f$
 
   \f$ L^p = ||x||_p = (|x_1|^p + |x_2|^p + ... + |x_n|^p ) ^ \frac{1}{p} \f$
-  
+
   If p = 1, the result is the Manhattan distance.
 
@@ -134,5 +134,5 @@
 
   References:
-  
+
     - <a href="http://en.wikipedia.org/wiki/Lp_space">\f$L^p\f$ space</a> on
   Wikipedia
@@ -142,5 +142,5 @@
 
   \return the p-norm of v
- 
+
 */
 smpl_t fvec_alpha_norm (fvec_t * v, smpl_t p);
@@ -148,5 +148,5 @@
 /**  alpha normalisation
 
-  This function divides all elements of a vector by the p-norm as computed by 
+  This function divides all elements of a vector by the p-norm as computed by
 fvec_alpha_norm().
 
@@ -166,5 +166,5 @@
 
 /** remove the minimum value of the vector to each elements
-  
+
   \param v vector to remove minimum from
 
@@ -177,12 +177,12 @@
 position of a vector, taking the median among post elements before and up to
 pre elements after pos.
- 
+
   \param v input vector
   \param tmp temporary vector of length post+1+pre
-  \param post length of causal part to take before pos 
+  \param post length of causal part to take before pos
   \param pre length of anti-causal part to take after pos
-  \param pos index to compute threshold for 
-
-  \return moving median threshold value 
+  \param pos index to compute threshold for
+
+  \return moving median threshold value
 
 */
@@ -197,5 +197,5 @@
   \param v input vector
   \param tmp temporary vector of length post+1+pre
-  \param post length of causal part to take before pos 
+  \param post length of causal part to take before pos
   \param pre length of anti-causal part to take after pos
 
@@ -203,5 +203,5 @@
 void fvec_adapt_thres (fvec_t * v, fvec_t * tmp, uint_t post, uint_t pre);
 
-/** returns the median of a vector 
+/** returns the median of a vector
 
   The QuickSelect routine is based on the algorithm described in "Numerical
@@ -216,5 +216,5 @@
 
   \return the median of v
- 
+
 */
 smpl_t fvec_median (fvec_t * v);
@@ -249,11 +249,11 @@
 
 /** Quadratic interpolation using Lagrange polynomial.
- 
+
   Inspired from ``Comparison of interpolation algorithms in real-time sound
-processing'', Vladimir Arnost, 
-  
-  \param s0,s1,s2 are 3 consecutive samples of a curve 
+processing'', Vladimir Arnost,
+
+  \param s0,s1,s2 are 3 consecutive samples of a curve
   \param pf is the floating point index [0;2]
- 
+
   \return \f$ s0 + (pf/2.)*((pf-3.)*s0-2.*(pf-2.)*s1+(pf-1.)*s2); \f$
 
Index: src/musicutils.h
===================================================================
--- src/musicutils.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/musicutils.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2003-2013 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
@@ -30,9 +30,9 @@
 #endif
 
-/** create window 
+/** create window
 
   \param window_type type of the window to create
   \param size length of the window to create (see fvec_set_window())
- 
+
 */
 fvec_t *new_aubio_window (char_t * window_type, uint_t size);
@@ -50,5 +50,5 @@
 
   References:
-    
+
     - <a href="http://en.wikipedia.org/wiki/Window_function">Window
 function</a> on Wikipedia
@@ -69,5 +69,5 @@
 
   \param phase unwrapped phase to map to the unit circle
-  
+
   \return equivalent phase wrapped to the unit circle
 
@@ -94,5 +94,5 @@
 
 /** clean up cached memory at the end of program
- 
+
   This function should be used at the end of programs to purge all cached
   memory. So far it is only useful to clean FFTW's cache.
@@ -138,5 +138,5 @@
 
 /** check if buffer level in dB SPL is under a given threshold
- 
+
   \param v vector to get level from
   \param threshold threshold in dB SPL
Index: src/types.h
===================================================================
--- src/types.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/types.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2003-2013 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2003-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.
@@ -23,7 +23,7 @@
 
 /** \file
- 
+
   Definition of data types used in aubio
- 
+
 */
 
Index: src/vecutils.h
===================================================================
--- src/vecutils.h	(revision 45989463296ac74bd151affc216eeb83a93c919e)
+++ src/vecutils.h	(revision 0683ee200bed4b17abe35f593daa216aa9ce4775)
@@ -1,4 +1,4 @@
 /*
-  Copyright (C) 2009-2013 Paul Brossier <piem@aubio.org>
+  Copyright (C) 2009-2015 Paul Brossier <piem@aubio.org>
 
   This file is part of aubio.